Index: django/conf/locale/es/LC_MESSAGES/django.po
===================================================================
--- django/conf/locale/es/LC_MESSAGES/django.po	(revisión: 8547)
+++ django/conf/locale/es/LC_MESSAGES/django.po	(copia de trabajo)
@@ -3942,6 +3942,11 @@
 msgid "Enter a valid IPv4 address."
 msgstr "Introduzca una dirección IPv4 válida."
 
+#: forms/formsets.py:242
+#: forms/formsets.py:244
+msgid "Order"
+msgstr "Orden"
+
 #: forms/models.py:514
 msgid "Select a valid choice. That choice is not one of the available choices."
 msgstr "Escoja una opción válida. Esa opción no está entre las disponibles."
Index: django/conf/locale/es/LC_MESSAGES/django.mo
===================================================================
No se puede mostrar: el archivo está marcado como binario.
svn:mime-type = application/octet-stream
Index: django/forms/formsets.py
===================================================================
--- django/forms/formsets.py	(revisión: 8534)
+++ django/forms/formsets.py	(copia de trabajo)
@@ -1,6 +1,7 @@
 from forms import Form
 from django.utils.encoding import StrAndUnicode
 from django.utils.safestring import mark_safe
+from django.utils.translation import ugettext_lazy as _
 from fields import IntegerField, BooleanField
 from widgets import Media, HiddenInput
 from util import ErrorList, ValidationError
@@ -238,11 +239,11 @@
         if self.can_order:
             # Only pre-fill the ordering field for initial forms.
             if index < self._initial_form_count:
-                form.fields[ORDERING_FIELD_NAME] = IntegerField(label='Order', initial=index+1, required=False)
+                form.fields[ORDERING_FIELD_NAME] = IntegerField(label=_(u'Order'), initial=index+1, required=False)
             else:
-                form.fields[ORDERING_FIELD_NAME] = IntegerField(label='Order', required=False)
+                form.fields[ORDERING_FIELD_NAME] = IntegerField(label=_(u'Order'), required=False)
         if self.can_delete:
-            form.fields[DELETION_FIELD_NAME] = BooleanField(label='Delete', required=False)
+            form.fields[DELETION_FIELD_NAME] = BooleanField(label=_(u'Delete'), required=False)
 
     def add_prefix(self, index):
         return '%s-%s' % (self.prefix, index)
Index: tests/regressiontests/forms/formsets.py
===================================================================
--- tests/regressiontests/forms/formsets.py	(revisión: 8534)
+++ tests/regressiontests/forms/formsets.py	(copia de trabajo)
@@ -432,6 +432,57 @@
 [{'votes': 900, 'DELETE': True, 'ORDER': 2, 'choice': u'Fergie'}]
 
 
+# FormSets with ordering + deletion and internationalization ##################
+
+>>> from django.utils.translation import activate, deactivate
+>>> ChoiceFormSet = formset_factory(Choice, can_order=True, can_delete=True)
+
+>>> initial = [
+...     {'choice': u'Calexico', 'votes': 100},
+...     {'choice': u'Fergie', 'votes': 900},
+...     {'choice': u'The Decemberists', 'votes': 500},
+... ]
+>>> formset = ChoiceFormSet(initial=initial, auto_id=False, prefix='choices')
+>>> for form in formset.forms:
+...    print form.as_ul()
+<li>Choice: <input type="text" name="choices-0-choice" value="Calexico" /></li>
+<li>Votes: <input type="text" name="choices-0-votes" value="100" /></li>
+<li>Order: <input type="text" name="choices-0-ORDER" value="1" /></li>
+<li>Delete: <input type="checkbox" name="choices-0-DELETE" /></li>
+<li>Choice: <input type="text" name="choices-1-choice" value="Fergie" /></li>
+<li>Votes: <input type="text" name="choices-1-votes" value="900" /></li>
+<li>Order: <input type="text" name="choices-1-ORDER" value="2" /></li>
+<li>Delete: <input type="checkbox" name="choices-1-DELETE" /></li>
+<li>Choice: <input type="text" name="choices-2-choice" value="The Decemberists" /></li>
+<li>Votes: <input type="text" name="choices-2-votes" value="500" /></li>
+<li>Order: <input type="text" name="choices-2-ORDER" value="3" /></li>
+<li>Delete: <input type="checkbox" name="choices-2-DELETE" /></li>
+<li>Choice: <input type="text" name="choices-3-choice" /></li>
+<li>Votes: <input type="text" name="choices-3-votes" /></li>
+<li>Order: <input type="text" name="choices-3-ORDER" /></li>
+<li>Delete: <input type="checkbox" name="choices-3-DELETE" /></li>
+
+>>> activate('es')
+>>> for form in formset.forms:
+...    print form.as_ul()
+<li>Choice: <input type="text" name="choices-0-choice" value="Calexico" /></li>
+<li>Votes: <input type="text" name="choices-0-votes" value="100" /></li>
+<li>Orden: <input type="text" name="choices-0-ORDER" value="1" /></li>
+<li>Eliminar: <input type="checkbox" name="choices-0-DELETE" /></li>
+<li>Choice: <input type="text" name="choices-1-choice" value="Fergie" /></li>
+<li>Votes: <input type="text" name="choices-1-votes" value="900" /></li>
+<li>Orden: <input type="text" name="choices-1-ORDER" value="2" /></li>
+<li>Eliminar: <input type="checkbox" name="choices-1-DELETE" /></li>
+<li>Choice: <input type="text" name="choices-2-choice" value="The Decemberists" /></li>
+<li>Votes: <input type="text" name="choices-2-votes" value="500" /></li>
+<li>Orden: <input type="text" name="choices-2-ORDER" value="3" /></li>
+<li>Eliminar: <input type="checkbox" name="choices-2-DELETE" /></li>
+<li>Choice: <input type="text" name="choices-3-choice" /></li>
+<li>Votes: <input type="text" name="choices-3-votes" /></li>
+<li>Orden: <input type="text" name="choices-3-ORDER" /></li>
+<li>Eliminar: <input type="checkbox" name="choices-3-DELETE" /></li>
+>>> deactivate()
+
 # FormSet clean hook ##########################################################
 
 FormSets have a hook for doing extra validation that shouldn't be tied to any